//+------------------------------------------------------------------+
//|                                                  Custom MACD.mq4 |
//|                      Copyright  2004, MetaQuotes Software Corp. |
//|                                       http://www.metaquotes.net/ |
//+------------------------------------------------------------------+
#property  copyright "Copyright  2004, MetaQuotes Software Corp."
#property  link      "http://www.metaquotes.net/"
//---- indicator settings
#property  indicator_separate_window
#property  indicator_buffers 4
#property  indicator_color1  Silver
#property  indicator_color2  DeepPink
#property  indicator_color3  LawnGreen
#property  indicator_color4  Gold

extern  double   alf=0.00581938;        
extern  double   bet=0.00000707;   
extern  double   sig=0.00001133;
extern  double   Di =0.0002;       

extern int Aver_Bars=3;           //    

//extern  
int    History=998;

//---- indicator buffers
double     Buffer_0[];
double     Buffer_1[];
double     Buffer_2[];
double     Buffer_3[];

//+------------------------------------------------------------------+
//| Custom indicator initialization function                         |
//+------------------------------------------------------------------+
int init()
  {
//---- drawing settings
   SetIndexStyle(0,DRAW_HISTOGRAM);
   SetIndexStyle(1,DRAW_LINE);
   SetIndexStyle(2,DRAW_LINE);
   SetIndexStyle(3,DRAW_LINE);
   IndicatorDigits(Digits+Digits);
//---- indicator buffers mapping
   SetIndexBuffer(0,Buffer_0);
   SetIndexBuffer(1,Buffer_1);
   SetIndexBuffer(2,Buffer_2);
   SetIndexBuffer(3,Buffer_3);
//---- name for DataWindow and indicator subwindow label
   IndicatorShortName("Ka-Ka");
   SetIndexLabel(0,"Buffer_0");
   SetIndexLabel(1,"Buffer_1");
   SetIndexLabel(2,"Buffer_2");
   SetIndexLabel(3,"Buffer_3");
//---- initialization done
   return(0);
  }
//+------------------------------------------------------------------+
//| Moving Averages Convergence/Divergence                           |
//+------------------------------------------------------------------+
int start()
  {
   int      i,Counted_bars,n;
   double   Ma_b,Ma_m,Sum_H,Sum_L;
//--------------------------------------------------------------------
   Counted_bars=IndicatorCounted(); //    
   i=Bars-Counted_bars-1;           //   
   if (i>History-1) i=History-1;    //     ...   .
   while(i>0)                       //    
     {
      //    ( )
      
      Ma_b=iCustom(NULL,0,"04_Kal",alf,bet,sig,Di,0,i);
      Ma_m=iCustom(NULL,0,"04_Kal",alf,bet,sig,Di,1,i);
      Buffer_0[i]=(Ma_m-Ma_b)/Point;             //  0   i- 
      
      //Cena-Cena
      Ma_b=iCustom(NULL,0,"04_Kal",alf,bet,sig,Di,0,i);
      Ma_m=iCustom(NULL,0,"04_Kal",alf,bet,sig,Di,0,i+1);
      Buffer_1[i]=(Ma_b-Ma_m)/Point;
      
      //
      Sum_H=0;                      //    
      Sum_L=0;                      //    
      for(n=i;n<=i+Aver_Bars-1;n++) //    
        {
         Sum_H=Sum_H + Buffer_0[n];     //   
         Sum_L=Sum_L + Buffer_1[n];     //   
        }
      Buffer_2[i]=Sum_H/Aver_Bars;     //  2   i- 
      Buffer_3[i]=Sum_L/Aver_Bars;     //  3   i- 
     
      i--;                          //    
     }
//--------------------------------------------------------------------
   return(0);
  }
//+------------------------------------------------------------------+


